$
$  TOPPERS ATK2
$      Toyohashi Open Platform for Embedded Real-Time Systems
$      Automotive Kernel Version 2
$
$  Copyright (C) 2008-2015 by Center for Embedded Computing Systems
$              Graduate School of Information Science, Nagoya Univ., JAPAN
$  Copyright (C) 2011-2015 by FUJI SOFT INCORPORATED, JAPAN
$  Copyright (C) 2011-2013 by Spansion LLC, USA
$  Copyright (C) 2011-2015 by NEC Communication Systems, Ltd., JAPAN
$  Copyright (C) 2011-2015 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
$  Copyright (C) 2011-2014 by Renesas Electronics Corporation, JAPAN
$  Copyright (C) 2011-2015 by Sunny Giken Inc., JAPAN
$  Copyright (C) 2011-2015 by TOSHIBA CORPORATION, JAPAN
$  Copyright (C) 2011-2015 by Witz Corporation
$  Copyright (C) 2014-2015 by AISIN COMCRUISE Co., Ltd., JAPAN
$  Copyright (C) 2014-2015 by eSOL Co.,Ltd., JAPAN
$  Copyright (C) 2014-2015 by SCSK Corporation, JAPAN
$
$  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
$  ܥեȥѤΤޤࡥʲƱˤѡʣ
$  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
$  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
$      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
$      ˴ޤޤƤ뤳ȡ
$  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
$      ѤǤǺۤˤϡۤȼɥȡ
$      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
$      ̵ݾڵǺܤ뤳ȡ
$  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
$      ѤǤʤǺۤˤϡΤ줫ξ
$      ȡ
$    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
$        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
$    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
$        𤹤뤳ȡ
$  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
$      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
$      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
$      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
$      դ뤳ȡ
$
$  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
$  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
$  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
$  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
$
$  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
$  TOPPERSץȤϡܥեȥ˴ؤơλŪ
$  ФŬޤơʤݾڤԤʤޤܥեȥ
$  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
$  Ǥʤ
$
$  $Id: kernel_check.tf 677 2015-03-24 02:52:27Z t_ishikawa $
$

$INCLUDE "cfg2_out.tf"$

$
$  ؿƬϤΥå
$
$IF CHECK_FUNC_ALIGN || CHECK_FUNC_NONNULL$
$	// ƬϤΥ饤å
	$tinib = SYMBOL("tinib_table")$
	$FOREACH tskid TSK.ID_LIST$
		$task = PEEK(tinib + offsetof_TINIB_task, sizeof_FunctionRefType)$
		$IF CHECK_FUNC_ALIGN && (task & (CHECK_FUNC_ALIGN - 1)) != 0$
			$ERROR TSK.TEXT_LINE[tskid]$$FORMAT(_("%1% of %2% `%3%\' is not aligned"), "task", "TINIB", tskid)$$END$
		$END$
$		// ƬϤNULLå
		$IF CHECK_FUNC_NONNULL && task == 0$
			$ERROR TSK.TEXT_LINE[tskid]$$FORMAT(_("%1% of %2% `%3%\' is null"),	"task", "TINIB", tskid)$$END$
		$END$
		$tinib = tinib + sizeof_TINIB$
	$END$

$	// 顼λƬϤΥå
	$alminib = SYMBOL("alminib_table")$
	$FOREACH almid ALM.ID_LIST$
		$action = PEEK(alminib + offsetof_ALMINIB_action, sizeof_FunctionRefType)$
		$IF CHECK_FUNC_ALIGN && (action & (CHECK_FUNC_ALIGN - 1)) != 0$
			$ERROR ALM.TEXT_LINE[almid]$$FORMAT(_("%1% of %2% `%3%\' is not aligned"), "action", "alarm", almid)$$END$
		$END$
		$IF CHECK_FUNC_NONNULL && action == 0$
			$ERROR ALM.TEXT_LINE[almid]$$FORMAT(_("%1% of %2% `%3%\' is null"),	"action", "alarm", almid)$$END$
		$END$
		$alminib = alminib + sizeof_ALMINIB$
	$END$

$	//ϡɥ󥿤νؿ
	$HWCNTFUNC_VALID = { VALUE("init",0),VALUE("start",1),VALUE("stop",2),VALUE("set",3),VALUE("get",4),
	VALUE("cancel",5),VALUE("trigger",6),VALUE("intclear",7),VALUE("intcancel",8),VALUE("increment",9) }$

$	// ϡɥ󥿤νؿΥ饤å
	$hwcntinib = SYMBOL("hwcntinib_table")$
	$FOREACH hwcntid HWCNT.ID_LIST$
		$FOREACH memberid HWCNTFUNC_VALID$
			$offsetofmember = offsetof_HWCNTINIB_init + (sizeof_FunctionRefType * memberid)$
			$hwfunc = PEEK(hwcntinib + offsetofmember, sizeof_FunctionRefType)$
			$IF CHECK_FUNC_ALIGN && (hwfunc & (CHECK_FUNC_ALIGN - 1)) != 0$
				$ERROR HWCNT.TEXT_LINE[hwcntid]$$FORMAT(_("%1% of %2% in `%3%\' is not aligned"), memberid, "HWCNTINIB", hwcntid)$$END$
			$END$
$			// ϡɥ󥿤νؿNULLå
			$IF CHECK_FUNC_NONNULL && hwfunc == 0$
				$ERROR HWCNT.TEXT_LINE[hwcntid]$$FORMAT(_("%1% of %2% in `%3%\' is null"), memberid, "HWCNTINIB", hwcntid)$$END$
			$END$
		$END$
		$hwcntinib = hwcntinib + sizeof_HWCNTINIB$
	$END$
$END$

$
$  åΰƬϤΥå
$
$IF CHECK_STACK_ALIGN || CHECK_STACK_NONNULL$
$	// ΥåΰƬϤΥå
	$tinib = SYMBOL("tinib_table")$
	$FOREACH tskid TSK.ID_LIST$
		$IF USE_TSKINICTXB$
			$stk = GET_STK_TSKINICTXB(tinib)$
		$ELSE$
			$stk = PEEK(tinib + offsetof_TINIB_stk, sizeof_void_ptr)$
		$END$
		$IF CHECK_STACK_ALIGN && (stk & (CHECK_STACK_ALIGN - 1)) != 0$
			$ERROR TSK.TEXT_LINE[tskid]$$FORMAT(_("%1% `%2%\' of `%3%\' is not aligned"), "stk", TSK.STK[tskid], tskid)$$END$
		$END$
		$IF CHECK_STACK_NONNULL && stk == 0$
			$ERROR TSK.TEXT_LINE[tskid]$$FORMAT(_("%1% `%2%\' of `%3%\' is null"), "stk", TSK.STK[tskid], tskid)$$END$
		$END$
		$tinib = tinib + sizeof_TINIB$
	$END$

$	// 󥿥ƥѤΥåΰƬϤΥå
	$ostk_addr = PEEK(SYMBOL("_ostk"), sizeof_void_ptr)$
	$IF CHECK_STACK_ALIGN && (ostk_addr & (CHECK_STACK_ALIGN - 1)) != 0$
		$ERROR OSTK.TEXT_LINE[1]$$FORMAT(_("%1% `%2%\' is not aligned"), "stk", OSTK.STK[1])$$END$
	$END$
	$IF CHECK_STACK_NONNULL && ostk_addr == 0$
		$ERROR OSTK.TEXT_LINE[1]$$FORMAT(_("%1% `%2%\' is null"), "stk", OSTK.STK[1])$$END$
	$END$
$END$
